"use strict";
var browse_the_web_1 = require('../abilities/browse_the_web');
var Attribute = (function () {
    function Attribute(target) {
        this.target = target;
    }
    Attribute.of = function (target) {
        return new Attribute(target);
    };
    Attribute.prototype.called = function (name) {
        return new AttributeValue(this.target, name);
    };
    return Attribute;
}());
exports.Attribute = Attribute;
var AttributeValue = (function () {
    function AttributeValue(target, attribute) {
        this.target = target;
        this.attribute = attribute;
    }
    AttributeValue.prototype.answeredBy = function (actor) {
        return browse_the_web_1.BrowseTheWeb.as(actor).locate(this.target).getAttribute(this.attribute);
    };
    return AttributeValue;
}());

//# sourceMappingURL=attribute.js.map
