import { ActivityFinished, ActivityStarts, DomainEvent } from '../../serenity/domain';
import { FileSystem } from '../../serenity/io/file_system';
import { Stage, StageCrewMember } from '../../serenity/stage';
export declare const TakeAPicture: {
    Before_Activity: typeof ActivityStarts[];
    After_Activity: typeof ActivityFinished[];
    Before_And_After_Activity: (typeof ActivityStarts | typeof ActivityFinished)[];
};
export declare function photographer(eventsOfInterest?: {
    new (v: any): DomainEvent<any>;
}[], pathToReports?: string): StageCrewMember;
export declare class Photographer implements StageCrewMember {
    private fs;
    private naming;
    private stage;
    private eventsOfInterest;
    constructor(eventsOfInterest: {
        new (v: any): DomainEvent<any>;
    }[], fs: FileSystem, naming?: PictureNamingStrategy);
    assignTo(stage: Stage): void;
    notifyOf(event: DomainEvent<any>): void;
    private whenActivityStarts(event);
    private whenActivityFinished(event);
    private takeAPhotoAndSendAReceipt(subject, timestamp);
    private photographWorkOf(actor);
}
export interface PictureNamingStrategy {
    nameFor(base64encodedData: string): string;
}
export declare class Md5HashedPictureNames implements PictureNamingStrategy {
    private fileExtension;
    constructor(fileExtension?: string);
    nameFor(base64encodedData: string): string;
    private extension();
}
