import { DomainEvent } from '../domain/events';
import { Stage } from './stage';
export interface StageCrewMember {
    assignTo(stage: Stage): any;
    notifyOf(event: DomainEvent<any>): void;
}
export declare class StageManager {
    private journal;
    private listeners;
    private wip;
    constructor(journal: Journal);
    notifyOf(event: DomainEvent<any>): void;
    informOfWorkInProgress<T>(promise: Promise<T>): void;
    allDone(): Promise<any[]>;
    registerInterestIn(eventsOfInterest: {
        new (value: any): DomainEvent<any>;
    }[], crewMember: StageCrewMember): void;
    readTheJournal(): DomainEvent<any>[];
    readNewJournalEntriesAs(readerId: string): DomainEvent<any>[];
}
export declare class Journal {
    private events;
    private bookmarks;
    /**
     * Records an event and stores it in memory
     *
     * @param event
     */
    record(event: DomainEvent<any>): void;
    /**
     * Returns a list of all the events ever recorded
     *
     * @return {Event[]} a list of events
     */
    read(): DomainEvent<any>[];
    /**
     * Returns a list of all the events recorded since you last checked
     *
     * @return {Event[]} a list of events
     */
    readAs(readerId: string): DomainEvent<any>[];
}
